import RPi.GPIO as GPIO
import time
from pyowm.owm import OWM
from pyowm.utils import timestamps
from datetime import datetime

#set up GPIO
GPIO.setmode(GPIO.BOARD)
GPIO.setwarnings(False)

#change these numbers if needed to reflect how you've wired up your LEDs
led1Pin = 38
led2Pin = 36
led3Pin = 32
led4Pin = 16
led5Pin = 24
led6Pin = 18
led7Pin = 26
led8Pin = 22

GPIO.setup(led1Pin, GPIO.OUT)
GPIO.output(led1Pin, GPIO.LOW)
GPIO.setup(led2Pin, GPIO.OUT)
GPIO.output(led2Pin, GPIO.LOW)
GPIO.setup(led3Pin, GPIO.OUT)
GPIO.output(led3Pin, GPIO.LOW)
GPIO.setup(led4Pin, GPIO.OUT)
GPIO.output(led4Pin, GPIO.LOW)
GPIO.setup(led5Pin, GPIO.OUT)
GPIO.output(led5Pin, GPIO.LOW)
GPIO.setup(led6Pin, GPIO.OUT)
GPIO.output(led6Pin, GPIO.LOW)
GPIO.setup(led7Pin, GPIO.OUT)
GPIO.output(led7Pin, GPIO.LOW)
GPIO.setup(led8Pin, GPIO.OUT)
GPIO.output(led8Pin, GPIO.LOW)

#forecast variables - these values determine the maximum temperature in celsius for the respective LED to activate.
#they can be changed to your preference
wrapupmax = 5
coatmax = 11
jumpermax = 18
#this variable determines how high the UV value needs to be to light the sunscreen LED
UVlimit = 5

#API settings
#replace the key below with the key for your own Open Weather Map API
API_key = "XXXXXXXXXXXXXXXXXX"
lattitude = "XXXXX"
longitude = "XXXXX"

#this animation runs when the code starts up and as a loading display when there is no connection 
def runAnimation():
    GPIO.output(led7Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led7Pin, GPIO.LOW)
    GPIO.output(led8Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led8Pin, GPIO.LOW)
    GPIO.output(led1Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led1Pin, GPIO.LOW)
    GPIO.output(led2Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led2Pin, GPIO.LOW)
    GPIO.output(led3Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led3Pin, GPIO.LOW)
    GPIO.output(led4Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led4Pin, GPIO.LOW)
    GPIO.output(led5Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led5Pin, GPIO.LOW)
    GPIO.output(led6Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led6Pin, GPIO.LOW)

    GPIO.output(led5Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led5Pin, GPIO.LOW)
    GPIO.output(led4Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led4Pin, GPIO.LOW)
    GPIO.output(led3Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led3Pin, GPIO.LOW)
    GPIO.output(led2Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led2Pin, GPIO.LOW)
    GPIO.output(led1Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led1Pin, GPIO.LOW)
    GPIO.output(led8Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led8Pin, GPIO.LOW)
    GPIO.output(led7Pin, GPIO.HIGH)
    time.sleep(0.1)
    GPIO.output(led7Pin, GPIO.LOW)

#this function accesses the weather forecast from OpenWeatherMap and turns on/off the designated LEDs     
def weatherUpdate():
    owm=OWM(API_key)
    mgr = owm.weather_manager()
    try:
        one_call = mgr.one_call(lat=lattitude, lon=longitude)
        now = datetime.now()
        dt_string = now.strftime("%d/%m/%Y %H:%M:%S")
        print(dt_string)	
        currentfeelslike = one_call.current.temperature('celsius').get('feels_like', None)
        if currentfeelslike <= wrapupmax:
            print("Wrap up! (" + str(currentfeelslike) + "C)")
            GPIO.output(led1Pin, GPIO.LOW)
            GPIO.output(led2Pin, GPIO.LOW)
            GPIO.output(led3Pin, GPIO.LOW)
            GPIO.output(led4Pin, GPIO.HIGH)
        elif currentfeelslike > wrapupmax and currentfeelslike <= coatmax:
            print("Wear a coat (" + str(currentfeelslike) + "C)")
            GPIO.output(led1Pin, GPIO.LOW)
            GPIO.output(led2Pin, GPIO.LOW)
            GPIO.output(led3Pin, GPIO.HIGH)
            GPIO.output(led4Pin, GPIO.LOW)
        elif currentfeelslike > coatmax and currentfeelslike <= jumpermax:
            print("Wear a jumper(" + str(currentfeelslike) + "C)")
            GPIO.output(led1Pin, GPIO.LOW)
            GPIO.output(led2Pin, GPIO.HIGH)
            GPIO.output(led3Pin, GPIO.LOW)
            GPIO.output(led4Pin, GPIO.LOW)
        else:
            print("Wear a t-shirt (" + str(currentfeelslike) + "C)")
            GPIO.output(led1Pin, GPIO.HIGH)
            GPIO.output(led2Pin, GPIO.LOW)
            GPIO.output(led3Pin, GPIO.LOW)
            GPIO.output(led4Pin, GPIO.LOW)
            
        status = one_call.forecast_daily[0].detailed_status
        precipitation = one_call.forecast_daily[0].precipitation_probability
        if precipitation >= 0.70:
            if "light rain" or "moderate rain" in status:
                print("Light rain (" + str(precipitation*100) + "%)")
                GPIO.output(led5Pin, GPIO.HIGH)
                GPIO.output(led6Pin, GPIO.LOW)
            elif "heavy rain" in status:
                print("Moderate or heavy rain (" + str(precipitation*100) + "%)")
                GPIO.output(led5Pin, GPIO.LOW)
                GPIO.output(led6Pin, GPIO.HIGH)
            else:
                GPIO.output(led5Pin, GPIO.LOW)
                GPIO.output(led6Pin, GPIO.LOW)            
        if "snow" in status:
            GPIO.output(led8Pin, GPIO.HIGH)
        else:
            GPIO.output(led8Pin, GPIO.LOW)
            
        UVI = one_call.forecast_daily[0].uvi
        sunrise = one_call.forecast_daily[0].sunrise_time()
        sunset = one_call.forecast_daily[0].sunset_time()
        
        if time.time() > sunrise and time.time() < sunset - 3600:
            if UVI >= UVlimit:
                print("Wear sunscreen (UVI: " + str(UVI) + ")")
                GPIO.output(led7Pin, GPIO.HIGH)
            else:
                GPIO.output(led7Pin, GPIO.LOW)
        else:
            GPIO.output(led7Pin, GPIO.LOW)
    except Exception as errormsg:
        print("Connection error")
        print(errormsg)
        runAnimation()
        time.sleep(2)
        weatherUpdate()

def reset_GPIO():
    GPIO.output(led1Pin, GPIO.LOW)
    GPIO.output(led2Pin, GPIO.LOW)

runAnimation()

while True:

    weatherUpdate()
#change the number below to set how often in seconds the display updates
    time.sleep(600)

